
// VMCDlg.cpp : implementation file
//---------------------------------
#include "stdafx.h"
#include "VMC.h"
#include "VMCDlg.h"
#include "MDBEngine.h"
#include "EXEDefines.h"
#include "PriceSetup.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CAboutDlg dialog used for App About
//------------------------------------

class CAboutDlg : public CDialog
//==============================
{
public:
	CAboutDlg();
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX); // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
//==============================================
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
//================================================
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CVMCDlg dialog
//---------------

CVMCDlg::CVMCDlg(CWnd* pParent)	: CDialog(CVMCDlg::IDD, pParent)
//==============================================================
{
	//{{AFX_DATA_INIT(CVMCDlg)
	m_Display = _T("");
	m_ExactChange = FALSE;
	m_FreeVend = FALSE;
	m_Disable = FALSE;
	m_Decimals = _T("");
	m_Scaling = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon=AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_dwScaling=1;
}

void CVMCDlg::DoDataExchange(CDataExchange* pDX)
//==============================================
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVMCDlg)
	DDX_Text(pDX, IDC_DISPLAY, m_Display);
	DDX_Check(pDX, IDC_EXACT, m_ExactChange);
	DDX_Check(pDX, IDC_FREEVEND, m_FreeVend);
	DDX_Check(pDX, IDC_DISABLE, m_Disable);
	DDX_Text(pDX, IDC_DECIMALS, m_Decimals);
	DDX_Text(pDX, IDC_SCALING, m_Scaling);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVMCDlg, CDialog)
	//{{AFX_MSG_MAP(CVMCDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_DISABLE, OnDisable)
	ON_BN_CLICKED(IDC_FREEVEND, OnFreevend)
	ON_BN_CLICKED(IDC_SELECTION_1, OnSelection1)
	ON_BN_CLICKED(IDC_SELECTION_2, OnSelection2)
	ON_BN_CLICKED(IDC_SELECTION_3, OnSelection3)
	ON_BN_CLICKED(IDC_SELECTION_4, OnSelection4)
	ON_BN_CLICKED(IDC_VENDFAILURE, OnVendfailure)
	ON_BN_CLICKED(IDC_VENDSUCCESS, OnVendsuccess)
	ON_COMMAND(IDM_ABOUTBOX, OnAboutbox)
	ON_WM_SYSCOMMAND()
	ON_COMMAND(IDM_PRICE_SETUP, OnPriceSetup)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_VMC_STATUS,CVMCDlg::OnVMCStatus)
END_MESSAGE_MAP()

// CVMCDlg message handlers
//-------------------------

void CVMCDlg::OnAboutbox() 
//========================
{
	CAboutDlg AboutDlg;
	AboutDlg.DoModal();
}

BOOL CVMCDlg::OnInitDialog()
//==========================
{
	m_Disable=true;
	CDialog::OnInitDialog();

	// Set the icon for this dialog. The framework does this automatically
	// when the application's main window is not a dialog.
	//--------------------------------------------------------------------
	SetIcon(m_hIcon,TRUE); // Set big icon
	SetIcon(m_hIcon,FALSE); // Set small icon
	
	// Initialize MDB engine
	//----------------------
	VMC_SETUP Setup;
	Setup.lParam=(LPARAM)this;
	Setup.hParent=m_hWnd;
	Setup.dwDevice=0;
	if (!ExecutiveCreate(&Setup))
	{
		TRACE(_T("Failed to create VMC\r\n"));
	}
	return true;
}

// If you add a minimize button to your dialog, you will need the code below
// to draw the icon. For MFC applications using the document/view model,
// this is automatically done for you by the framework.
//--------------------------------------------------------------------------

void CVMCDlg::OnPaint() 
//=====================
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		SendMessage(WM_ICONERASEBKGND,(WPARAM)dc.GetSafeHdc(),0);

		// Center icon in client rectangle
		//--------------------------------
		int cxIcon=GetSystemMetrics(SM_CXICON);
		int cyIcon=GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x=(rect.Width()-cxIcon+1)/2;
		int y=(rect.Height()-cyIcon+1)/2;

		// Draw the icon
		//--------------
		dc.DrawIcon(x,y,m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display
// while the user drags the minimized window.
//------------------------------------------------------

HCURSOR CVMCDlg::OnQueryDragIcon()
//================================
{
	return (HCURSOR)m_hIcon;
}

void CVMCDlg::OnDestroy() 
//=======================
{
	CDialog::OnDestroy();
	if (!ExecutiveDestroy())
	{
		TRACE(_T("Failed to destroy reader\r\n"));
	}
}

void CVMCDlg::OnDisable() 
//=======================
{
	DWORD dwStatus=0;
	UpdateData(true);
	if (m_Disable)
		dwStatus|=EXE_INHIBIT;
	if (m_FreeVend)
		dwStatus|=EXE_FREEVEND;
	ExecutiveControl(dwStatus);
}

void CVMCDlg::OnFreevend() 
//========================
{
	DWORD dwStatus=0;
	UpdateData(true);
	if (m_Disable)
		dwStatus|=EXE_INHIBIT;
	if (m_FreeVend)
		dwStatus|=EXE_FREEVEND;
	ExecutiveControl(dwStatus);
}

void CVMCDlg::OnVMCStatus(WPARAM wParam, LPARAM lParam)
//=====================================================
{
	switch (wParam)
	{
		case SS_VMC_DISPLAY:
		{
			VMC_DISPLAY Display;
			ExecutiveGetDisplay(&Display);
			m_Display.Format(_T("%d"),Display.dwAmount*Display.dwScaling);
			m_ExactChange=Display.bExactChange;
			m_dwScaling=Display.dwScaling;
			m_Scaling.Format(_T("%d"),Display.dwScaling);
			m_Decimals.Format(_T("%d"),Display.dwDecimalPoint);
			UpdateData(false);
			break;
		}
		case SS_VMC_VEND:
		{
			break;
		}
	}
}

void CVMCDlg::OnSelection1() 
//==========================
{
	ExecutivePrice(AfxGetApp()->GetProfileInt(_T("Setting"),_T("Price1"),1)/m_dwScaling);
}

void CVMCDlg::OnSelection2() 
//==========================
{
	ExecutivePrice(AfxGetApp()->GetProfileInt(_T("Setting"),_T("Price2"),2)/m_dwScaling);
}

void CVMCDlg::OnSelection3() 
//==========================
{
	ExecutivePrice(AfxGetApp()->GetProfileInt(_T("Setting"),_T("Price3"),3)/m_dwScaling);
}

void CVMCDlg::OnSelection4() 
//==========================
{
	ExecutivePrice(AfxGetApp()->GetProfileInt(_T("Setting"),_T("Price4"),4)/m_dwScaling);
}

void CVMCDlg::OnVendfailure() 
//===========================
{
	ExecutiveVend(EXE_VENDFAILURE);	
}

void CVMCDlg::OnVendsuccess() 
//===========================
{
	ExecutiveVend(EXE_VENDSUCCESS);
}

void CVMCDlg::OnPriceSetup() 
//==========================
{
	CPriceSetup PriceSetup;
	PriceSetup.DoModal();
}
